Package: muRL
Type: Package
Title: Mailmerge using R, LaTeX, and the Web
Version: 0.1-13
Date: 2023-08-21
Author: Ryan T. Moore <rtm@american.edu> and Andrew Reeves <reeves@wustl.edu>
Maintainer: Ryan T. Moore <rtm@american.edu>
Depends: utils, maps, stringr
Imports: graphics
Description: Provides mailmerge methods for reading spreadsheets of addresses and other relevant information to create standardized but customizable letters.  Provides a method for mapping US ZIP codes, including those of letter recipients.  Provides a method for parsing and processing html code from online job postings of the American Political Science Association.
License: GPL-3 | file LICENSE
URL: https://www.ryantmoore.org/software.murl.html
LazyLoad: yes
Packaged: 2023-08-21 23:23:23 UTC; rtm
NeedsCompilation: no
Repository: CRAN
Date/Publication: 2023-08-22 06:40:02 UTC
Built: R 4.6.0; ; 2026-04-28 07:20:39 UTC; unix

# muRL
Mailmerge using R, LaTeX, and the Web

The current CRAN version of `muRL` is 0-1.12 (2019-12-05).  The first version of 0.1-13 is compiled and the `.tar.gz` is visible in the `master` branch.  If you are working on this package and wish to create a branch on which to make your changes, make the new branch name short, grouped, and descriptive.

# murl: URL manipulation in Python, made simple

[![Travis CI](https://secure.travis-ci.org/berkerpeksag/murl.png)](http://travis-ci.org/berkerpeksag/murl)

murl is a tiny wrapper for the Python module
[urlparse](http://docs.python.org/library/urlparse.html).

## Installation

To install murl, simply:

```bash
$ pip install murl
```

## Usage

```py
from murl import Url


url = Url('https://bugzilla.mozilla.org/show_bug.cgi?id=698201#c0')
print url.scheme, url.host, url.querystring, url.fragment
# https bugzilla.mozilla.org id=698201 c0

url.scheme = 'http'
url.host = 'bugzilla.webkit.org'

print url
print url.url
print url.scheme
print url.host
print url.netloc
print url.host == url.netloc
# http://bugzilla.webkit.org/show_bug.cgi?id=698201#c0
# http://bugzilla.webkit.org/show_bug.cgi?id=698201#c0
# http
# bugzilla.webkit.org
# bugzilla.webkit.org
# True

url.path = 'list_bugs.cgi'
print url.path, url.url
# list_bugs.cgi http://bugzilla.webkit.org/list_bugs.cgi?id=698201#c0

url.fragment = 'c1'
print url.fragment
print url.url
# c1
# http://bugzilla.webkit.org/list_bugs.cgi?id=698201#c1

url.fragment = ''
print url.fragment
print url.url
# ''
# http://bugzilla.webkit.org/list_bugs.cgi?id=698201
```

## Hacking

To setup a local development environment for hacking:

1. Clone the repo:

    ```sh
    $ git clone git://github.com/berkerpeksag/murl.git
    $ cd murl
   ```

2. Create and activate a new virtual environment:

    ```sh
    $ virtualenv .
    $ source bin/activate
    ```

3. Install required dependencies:

    ```sh
    $ pip install -r requirements.txt
    ```

4. To run the tests, do:

    ```sh
    $ nosetests -v
    ```

## License

All files that are part of this project are covered by the following
license, except where explicitly noted.

> This Source Code Form is subject to the terms of the Mozilla Public
> License, v. 2.0. If a copy of the MPL was not distributed with this
> file, You can obtain one at http://mozilla.org/MPL/2.0/.

data(murljobs)

## Create mailmerge.tex required for LaTeX import
# write.murl(murljobs)

## Specify a file containing the letters' body text
## write.murl(murljobs, letter.file = "mybodytext.txt")

## Specify a string containing the letters' body text
# write.murl(murljobs, letter.text = "This is the whole body of my letters.")

## Specify salutation, valediction options (overwrites previous mailmerge.tex)
# write.murl(murljobs, file.name = "mailmerge.tex", salutation = "Greetings", 
#           sal.punct = ",", valediction = "Truly Yours,", include.opening = FALSE)
           
## Specify opening line also (overwrites previous mailmerge.tex)
# write.murl(murljobs, file.name = "mailmerge.tex", salutation = "Greetings", 
#           sal.punct = ",", valediction = "Truly Yours,", 
#           opening = "I am applying for the job as", include.opening = TRUE)

## Call murl object of sample addresses
data(murljobs)
zip.plot(murljobs)

## Read .csv to murl object
murljobs <- read.murl(system.file("extdata", "murljobs.csv", package = "muRL"))
## Specify US state to map
zip.plot(murljobs, map.type = "state", region = "maryland")

rm(stateMapEnv)

read.murl <- function(file = "murljobs.csv", header = TRUE, stringsAsFactors = 								FALSE, field.title = "title", field.fname = "fname" , 
								field.lname = "lname", fields.address = "address", 
								field.city = "city", field.state = "state", 
								field.zip = "zipcode", field.position = "position", 
								field.subfield = "subfield",  
								field.dept = "dept", 
								field.institution = "institution", field.instShort = "instShort",
								colClasses = c("character"), ...){
	
	## read data from local file or webpage
	if(is.data.frame(file)){
		data <- file
	}else{
	data <- read.csv(file, header = header, stringsAsFactors = stringsAsFactors, colClasses = colClasses, ...)
	}

	## Rename field titles to those expected by write.murl
	names(data)[which(names(data) == field.title)] <- "title"
	names(data)[which(names(data) == field.fname)] <- "fname"
	names(data)[which(names(data) == field.lname)] <- "lname"
	names(data)[grep(fields.address, names(data))] <- paste("address", 1:length(grep(fields.address, names(data))), sep="")

	names(data)[which(names(data) == field.city)] <- "city"
	names(data)[which(names(data) == field.state)] <- "state"
	names(data)[which(names(data) == field.zip)] <- "zip"		
	names(data)[which(names(data) == field.position)] <- "position"
	names(data)[which(names(data) == field.subfield)] <- "subfield"
	names(data)[which(names(data) == field.dept)] <- "dept"
	names(data)[which(names(data) == field.institution)] <- "institution"
	names(data)[which(names(data) == field.instShort)] <- "instShort"
	
	## Which are not == 5, 10?
	n510 <- which(!(nchar(data$zip) %in% c(5,10)))
	## Which are == 10, but lack hyphen?
	zl10 <- which(nchar(data$zip) == 10)
	nhyp <- zl10[-grep("-", data$zip[zl10])]
	## Of == 10 with hyphen, are they 5 then 4?
	yhyp <- zl10[grep("-", data$zip[zl10])]
	spl54 <- function(ddd){
		nchar(ddd) == c(5,4)
	}
	if(length(zl10)>0){
			yhypn <- yhyp[which(unlist(lapply(lapply(strsplit(data$zip[zl10[grep("-", data$zip[zl10])]], "-"), spl54), sum)) !=2)]
	}else{yhypn <- NULL}
	
	allns <- sort(unique(c(n510, nhyp, yhypn)))
	
	if(length(allns) > 0){
		warning("At least one postal code is of non-standard (US) form.  Please check postal code(s) of unit(s) ", paste(allns, collapse=" "), " and respecify if needed.")
	}
		return(data)	
}

write.murl <- function(object, file.name = "mailmerge.tex", salutation = "Dear", 
                       sal.punct = ":", 
                       address.string = "123 Venus Flytrap Way\\\\Cincinnati, 
OH 45201\\\\ \\texttt{jfever@wkrp.edu}\\\\ 
\\texttt{http://www.wkrp.edu/jfever}\\\\513-555-5664",
                       pad_if_zip4 = TRUE,
                       date = "\\today", letter.file = NULL, letter.text = NULL, 
                       valediction = "Sincerely,", signature = "Johnny Fever", 
                       opening = "", include.opening = FALSE,
                       closing = "", include.closing = FALSE,
                       contact_me = TRUE,
                       margin_geometry = NULL,
                       verbose = TRUE){
	
	##empty contents for .tex file
	empty <- ""
	## create the empty .tex file
	write(empty, file = file.name)
	
	write("%% Sample template for muRL by Moore and Reeves.  
	%% By pdflatex-ing this document, a pdf file will be generated, which will include letters for each address %specified in your jobs spreadsheet, and a sheet of mailing labels on the last page of the document.  
	%% See documentation for further details.

%% User must define body, return address, and specify any formatting preferences 
%% in the preamble of this document.  

\\documentclass[11pt]{letter} 
\\usepackage{graphicx} % required for envab package.
\\usepackage[avery5164label]{envlab} % generates labels appropriate for avery brand, number 5164.  More label formats are available.  Generate barcodes for ZIP codes ensuring faster delivery.  See http://ctan.tug.org/get/macros/latex/contrib/envlab/envlab.pdf for more information.
\\makelabels % generates mailing labels and includes them after letters.  Comment this out if you do not wish to generate labels.

%%margin options", file = file.name, append = TRUE)
	
	if(!is.null(margin_geometry)){
	  write(paste0("\\usepackage[top=", margin_geometry[1], "in,", "bottom=", margin_geometry[2], "in,",
	               "left=", margin_geometry[3], "in,", "right=", margin_geometry[4], "in]{geometry}"),
	        file = file.name, append = TRUE)
	}
	
	write("%%\\usepackage{fullpage}
%%font options
%\\usepackage{times}

\\address{%your return address.  If you are using letterhead, you should adjust the top margin and you should omit the street address here.
%\\vspace{2in}\\ %add white space here if using letterhead.", file = file.name, append = T)

	write(address.string, file = file.name, append = T)
	write("} %end of return address", file = file.name, append = T)
	write(paste("\\date{", date, "}", sep = ""), file = file.name, append = T)
	write(paste("\\signature{", signature, "} %your name, which will follow the valediction.", sep = ""), file = file.name, append = T)
	write("\\begin{document}	
\\def
\\body{%this defines the text of the body of your cover letter.  If specified by the user, the opening line is generated in R using muRL and is not show in the tex below.", file = file.name, append = T)
	if(!is.null(letter.file)){
		letter.file <- path.expand(letter.file)
		write(paste("\\input{", letter.file, "}}\n\n% begin letter and label generation", sep = ""), file = file.name, append = T)	
	}
	if(!is.null(letter.text)){	
		write(paste(letter.text, "} %end of define body.\n\n%begin letter and label generation", sep=""), file = file.name, append = T)
	}
	
	if(is.null(letter.file) && is.null(letter.text)){
		write("
I will complete my Ph.D. at WKRP University in the Department of Musicology and will defend my dissertation in June 1972.

My dissertation examines \\ldots

In addition to my dissertation, I have also worked on \\ldots 

In addition to my research, I believe I could be an an asset to your department through the courses I could offer \\ldots

I have included with this letter, two chapters of my dissertation, my \\emph{curriculum vitae}, an outline of my dissertation, and a summary of my teaching experiences.  You will also be receiving letters of recommendation from Professors Less Nessman, Jennifer Marlowe, and Herb Tarlek, which will arrive under separate cover.   Thank you for your consideration of my application.  I look forward to hearing from you.
} %end of define body.\n\n%begin letter and label generation", file = file.name, append = T)
	}
	
	# get address columns
	add.col <- grep("address", names(object))
	
	for(i in 1:nrow(object)){

		tmp <- object[i, add.col]
		tmp <- tmp[tmp != ""]
		
		# Pad short ZIP codes with a 0:
		if(pad_if_zip4 == TRUE){
		  if(nchar(object$zip[i]) %in% c(4, 9)){
		    object$zip[i] <- paste0("0", object$zip[i])
		    warning(paste0("In row ", i, ", ZIP code '", object$zip[i], 
		    "' was created by adding a leading 0 (zero)."))
		  }
		}
		
		form <- paste("\\begin{letter}\n{", 
			object$title[i], " ",
			object$fname[i], " ",
			object$lname[i], "\\\\",	
			paste(tmp, "\\\\", sep="", collapse = ""),
			object$city[i], " ",
			object$state[i], " ",
			object$zip[i], 
			paste("}\n\\opening{", salutation, sep=""),
        " ",
        object$title[i], " ",
        object$lname[i],
        sal.punct, 
        "}\n ",
        if(include.opening == TRUE){
        		paste(opening, " ",
        		      object$position[i], 
        		      " in ", object$subfield[i],
        		      " in the ", object$dept[i],
        		      " at ", object$institution[i],
        		      ".", sep = "")
        	},	       		
      
			  paste(" \\body \n"),
			
			  if(include.closing == TRUE){
			    
			    if(contact_me == TRUE){
			      contact_phrase <- "  Please don't hesitate to contact me if more information would be helpful."
			    }else{contact_phrase <- ""}
			    
			    paste(closing, " ",
			        object$position[i],
			        " in ",
			        object$subfield[i],
			        " at ",
			        object$instShort[i],
			        ".", contact_phrase, sep = "")
			  },	       		
        paste("\\closing{", valediction, "} \n\\end{letter}\n", sep=""),
        
			sep="")
        
      ## " \\body \n\\closing{\\myclosing} \n\\end{letter}\n",     
      write(form, file = file.name, append = T)
	}
	
	write("\\end{document}", file = file.name, append = T)
	
	if(verbose == TRUE){
	   	cat("Data stored as file `", file.name, "'.  \nThe current working directory is ", getwd(), "\n", sep="")
	}
}

apsahtml2csv <- function(directory, file.name, file.ext = ".htm", verbose = TRUE){
	
	jobs <- dir(directory, full.names = TRUE)[grep(file.ext, dir(directory))]
	
	for(i in 1:length(jobs)){
		
	  if(verbose == TRUE){
	    cat("Starting ", jobs[i], "\n")
	  }
		write("\n", jobs[i], append=T)
		
		data <- readLines(jobs[i])
		
		data <- data[grep("Job Detail</legend>", data):grep("</div></div>", data)]
		
		assign("listingid", getfield(data, "Job ID", 3, ".*>(.*)<.*", "\\1"))
		assign("startdate", getfield(data, "Start Date", 3, ".*>(.*)<.*",  "\\1"))
		if(length(startdate) > 1){
		  startdate <- startdate[1]
		}
		
		assign("deadline", getfield(data, "Application Deadline", 3, ".*>(.*)<.*", "\\1"))
		if(length(deadline) > 1){
			deadline <- deadline[1]
		}
		
		assign("position", getfield(data, "Title:", 4, ".*>(.*)<.*", "\\1"))
		position <- tolower(position)
		
		assign("subfield", getfield(data, "Subfield:", 4, ".*>(.*?)<.*>(.*?)<.*>(.*?)<.*>", "\\1"))
		if(length(subfield) > 1){
			subfield <- subfield[1]
		}
		
		assign("dept", getfield(data, "Department:", 4, ".*>(.*)<.*", "\\1"))
		assign("inst", getfield(data, "Company:", 4, ".*>(.*)<.*", "\\1"))
		
		assign("region", getfield(data, "Region:", 4, ".*>(.*)<.*", "\\1"))
		region <- str_trim(region)
		
		assign("salary", getfield(data, "Salary Range:", 5, ".*>(.*)<.*", "\\1" ))
		
		assign("desc", getdesc(data))
		assign("contact", getfield(data, "Contact:", 4, ".*>(.*)<.*", "\\1"))
		if(length(contact) == 0){
			contact <- ""
		}
		assign("phone", getfield(data, "Phone:", 4, ".*>(.*)<.*", "\\1"))
		if(length(phone) == 0){
			phone <- ""
		}
		
		subfield <- tolower(subfield)
		subfield <- gsub("american", "American", subfield)
		
		## 2015: some employers omit address:
		if(length(grep("Address:", data) > 0)){
			address <- data[grep("Address:", data):length(data)]
			## Get address line:
			address <- address[grep("<span id=", address)]
			
			## Remove HTML:
			begin.address <- stringr::str_locate(address, c(">", "</span"))[1, "end"] + 1
			end.address <- stringr::str_locate(address, c(">", "</span"))[2, "end"] - 6
			address <- substring(address, begin.address, end.address)
			address <- gsub("#", "\\\\#", address)
			
			## Split address into rows of address:
			address.split <- strsplit(address, "<br/>")[[1]]
			
			## Store ZIP code:
			zip.chars <- gregexpr("[0-9|-]", address.split[length(address.split)])[[1]]
			zip <- substring(address.split[length(address.split)], zip.chars[1], zip.chars[length(zip.chars)])
			zip <- gsub(" ", "", zip)
			
			## Get only letters:
			citystate.chars <- gregexpr("[a-z|A-Z]", address.split[length(address.split)])[[1]]
			citystate <-substring(address.split[length(address.split)], citystate.chars[1], citystate.chars[length(citystate.chars)])
			state <- substr(citystate, nchar(citystate)-1, nchar(citystate))
			
			if(state == ", "){state<-""}
			
			city <- substr(citystate,1, nchar(citystate)-3)
		}else{ ## if "Address:" is missing:
			city <- state <- zip <- ""
		}
		
		## Clean up description:
		desc <- gsub("pre style='font-family: Trebuchet MS,Arial; white-space: pre-wrap; width:100%;'>", "", desc)
		desc <- gsub("span style='font-family: Trebuchet MS,Arial; white-space: pre-wrap; width:100%;'>", "", desc)
		desc <- gsub("dnn_ctr4356_ViewJobBank_ViewJob_lb_JobText", "", desc)
		desc <- gsub("<span id=", "", desc)
		desc <- gsub("<br />", " ", desc)
		desc <- gsub("><", "", desc)
		desc <- str_trim(desc)
		
		## Create final data frame for output
		df <- data.frame(listingid = listingid, subfield = subfield, startdate = startdate, deadline = deadline, position = position, dept = dept,
		                 institution = inst, region = region, salary = salary, contact = contact, phone = phone, city = city, state = state, 
		                 zip = zip, desc = desc)
		
		if(length(grep("Address:", data) > 0)){
			## Make Address
			add.vec <- paste("address", 1:(length(address.split) - 1), sep="")
			
			for(j in 1:length(add.vec)){
				df <- cbind(df, address.split[j])
			}
			
			names(df)[(ncol(df) - (length(add.vec) - 1)):ncol(df)] <- add.vec
		}
		
		if(i == 1){
			myjobs <- df
		}else{
			myjobs <- merge(myjobs, df, all = TRUE)
		}
	}
		
	write.csv(myjobs, file = file.name, row.names = FALSE, na = "")

	if(verbose == TRUE){
	  cat("Data stored as file `", file.name, "'.  \nThe current working directory is ", getwd(), "\n", sep="")
	 }
}

zip.plot <- function(data, zip.file = system.file("extdata", "zips.tab", package = "muRL"), map.type = "state", cex = 1, col = "black", pch = 20, jitter.factor = NULL, ...){
	
	data$zip <- as.numeric(substr(data$zip, 1, 5))
	
	zips <- read.delim(zip.file, stringsAsFactor = FALSE)
	
	data.z <- merge(data, zips[,c("zip", "lat", "lon")], by.x = "zip", by.y = "zip", all.x = TRUE)

	maps::map(map.type, ...)
	if(!(is.null(jitter.factor))){
		data.z$lon <- jitter(data.z$lon, factor = jitter.factor)
		data.z$lat <- jitter(data.z$lat, factor = jitter.factor)
	}
	points(data.z$lon, data.z$lat, cex = cex, col = col, pch = pch)
}

\name{read.murl}
\Rdversion{1.1}
\alias{read.murl}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Read a .csv file or R dataframe of letter recipients}
\description{Reads a \code{.csv} file or R dataframe of letter recipients, processes the column names for \code{write.murl}, checks whether United States ZIP codes conform to standard formats, and reports potential problems to the user.}
\usage{
read.murl(file = "murljobs.csv", header = TRUE, stringsAsFactors = 
FALSE, field.title = "title", field.fname = "fname", field.lname = 
"lname", fields.address = "address", field.city = "city", 
field.state = "state", field.zip = "zipcode", field.position = 
"position", field.subfield = "subfield", field.dept = "dept", 
field.institution = "institution", field.instShort = "instShort", 
colClasses = c("character"), ...)
}

\arguments{
  \item{file}{the name of a \code{.csv} file or \R dataframe.}
  \item{header}{a logical for whether the first row of the input file or dataframe is a header row.}
  \item{stringsAsFactors}{a logical for whether character strings should be stored as factors with levels.}
  \item{field.title}{a character string giving the name of the column containing recipients' titles (such as ``Doctor", ``Mrs.", etc.).}
  \item{field.fname}{a character string giving the name of the column containing recipients' first names.}
  \item{field.lname}{a character string giving the name of the column containing recipients' last names.}
  \item{fields.address}{a character string common to the name(s) of the column(s) containing recipients' street mailing address information.  Each column will be printed as its own row in the mailing address.  See Details below for more.}
  \item{field.city}{a character string giving the name of the column containing recipients' cities.}
  \item{field.state}{a character string giving the name of the column containing recipients' states or provinces.}
  \item{field.zip}{a character string giving the name of the column containing recipients' United States ZIP or other postal codes.}
  \item{field.position}{a character string giving the name of the column containing recipient-specific information, such as the specific position for which one is applying.}
  \item{field.subfield}{a character string giving the name of the column containing recipient-specific information, such as the specific subfield for which one is applying.}
  \item{field.dept}{a character string giving the name of the column containing additional information, such as the specific department offering the position for which one is applying.}
  \item{field.institution}{a character string giving the name of the column containing additional information, such as the institution offering the position for which one is applying.}
  \item{field.instShort}{a character string giving the name of the column containing the shortened version of the name of the institution.  Optionally used in the closing.}
  \item{colClasses}{a vector of character strings indicating the class of each column.  Using \code{c(``character'')} ensures leading zeros in, for example, ZIP codes will be preserved.}
  \item{\dots}{other arguments to pass to \code{read.csv()} if the input file is a .csv file.}
}

\details{
Recipients' addresses are formatted for mailing as follows.  The first row contains the contents of the fields defined by \code{field.title}, \code{field.fname}, and \code{field.lname}.  Each of the fields defined by \code{fields.address} is formatted as a unique row.  The last row contains the contents of the fields defined by \code{field.city}, \code{field.state}, and \code{field.zip}.  

\code{fields.address} specifies the string common to the names of the columns containing the recipients' street addresses.  For example, if the user's file has the street address in columns named \code{addr1}, \code{addr2}, \code{...}, then the user should set \code{fields.address = "addr"}.

If the input file is an \R dataframe, then the argument \code{...} is ignored.
}

\value{An \R dataframe containing the relevant information for creating a set of standardized but customizable letters to be mailed.}

%%\references{
%% ~put references to the literature/web site here ~
%%}

\author{Ryan T. Moore \email{rtm@american.edu} and Andrew Reeves \email{reeves@wustl.edu}}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{\code{\link{write.murl}}, \code{\link{zip.plot}}
}

\examples{
## Specify path to .csv database of sample addresses
fpath <- system.file("extdata", "murljobs.csv", package = "muRL")

murljobs <- read.murl(fpath)
}

\keyword{IO}

\name{zip.plot}
\Rdversion{1.1}
\alias{zip.plot}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Plot US ZIP codes, including locations of letter recipients.}
\description{Using United States ZIP codes, plots on a map the location of letter recipients.  State or county boundaries may be displayed.}
\usage{
zip.plot(data, zip.file = system.file("extdata", "zips.tab", package = 
"muRL"), map.type = "state", cex = 1, col = "black", pch = 20, 
jitter.factor = NULL, ...)
}
\arguments{
  \item{data}{a dataframe with ZIP codes in a column named '\code{zip}', such as the output of \code{read.murl}.}
  \item{zip.file}{a character string naming a \code{.tab} file with the columns for the latitude and longitude of ZIP codes, such as '\code{zips.tab}' provided in the \code{murl} package (the default).}
  \item{map.type}{the type of map for \code{map()} from the \code{maps} library to create.  See Details for more.}
  \item{cex}{a numerical value giving the amount by which plotting text and symbols should be magnified relative to the default.  Accepts, for example, a vector of values which are recycled.}
  \item{col}{a specification for the plotting color.}
  \item{pch}{the plotting character for \code{map()} from the \code{maps} library to use.}
  \item{jitter.factor}{a numeric specifying by how much points should be jittered before plotting.  See Details below for more.}
  \item{\dots}{other arguments to pass to \code{map()} from the \code{maps} library.  See Details below for more.}
}
\details{
\code{map.type} can be any valid map from the \code{maps} package.  For plotting the location of United States ZIP codes, \code{usa}, \code{state}, or \code{county} should be used.

See \code{help(par)} for more details on \code{cex}, \code{col}, and \code{pch}.

See \code{help(jitter)} for more details on \code{jitter.factor}.  \code{zip.plot} jitters latitude and longitude separately using the same factor. 

To plot only a region within the selected \code{map.type}, include the \code{map} argument \code{region = }.  For example, \code{zip.plot(..., region = ``Maryland'')} would plot only the recipients with ZIP codes in the US state of Maryland.
}

\note{\code{zip.plot} calls the \code{map} function in the \code{maps} package.  The \code{map} function places an object called \code{stateMapEnv} in the user's workspace.
}

\author{
Ryan T. Moore \email{rtm@american.edu} and Andrew Reeves \email{reeves@wustl.edu}
}

\seealso{\code{\link{read.murl}}, \code{\link{zips}}}

\examples{
## Call murl object of sample addresses
data(murljobs)
zip.plot(murljobs)

## Read .csv to murl object
murljobs <- read.murl(system.file("extdata", "murljobs.csv", package = "muRL"))
## Specify US state to map
zip.plot(murljobs, map.type = "state", region = "maryland")
}

\name{write.murl}
\Rdversion{1.1}
\alias{write.murl}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Write a .tex file of recipient information to be processed by LaTeX}

\description{Reads an \R dataframe of letter recipient- and position-specific data, such as the output of \code{read.murl}.  Creates a \code{.tex} file of the relevant data and LaTeX code, which can then be processed directly by pdflatex, for example.}

\usage{
write.murl(object, file.name = "mailmerge.tex", salutation = "Dear", 
sal.punct = ":", address.string = "123 Venus Flytrap Way\\\\\\\\Cincinnati, 
OH 45201\\\\\\\\ \\\\texttt{jfever@wkrp.edu}\\\\\\\\ 
\\\\texttt{http://www.wkrp.edu/jfever}\\\\\\\\513-555-5664", 
pad_if_zip4 = TRUE,
date = "\\\\today", letter.file = NULL, letter.text = NULL, valediction = "Sincerely,", 
signature = "Johnny Fever", opening = "", include.opening = FALSE, 
closing = "", include.closing = FALSE, contact_me = TRUE,
margin_geometry = NULL,
verbose = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{a dataframe of mailmerge data, such as an output from \code{read.murl()}.}
  \item{file.name}{a character string specifying the file name (and optionally, path) for the output \code{.tex} file.  See Details below for more.}
  \item{salutation}{a character string specifying the salutation to be used in the letters.}
  \item{sal.punct}{a character string specifying the punctuation to be used at the end of the salutation.}
  \item{address.string}{a character string specifying the return address to be used in the letters.  Note that two slashes (\code{\\\\}) should be used for every one usual LaTeX slash.}
  \item{pad_if_zip4}{a logical indicating whether to add a leading 0 (zero) to 
  any ZIP code with 4 or 9 characters.  Defaults to \code{TRUE} and warns the user.}
  \item{date}{an optional character string specifying the date.  Defaults to the current date.}
  \item{letter.file}{an optional character string specifying a file containing the body text of the letters.  See Details below for more.}
  \item{letter.text}{an optional character string containing the body text of the letters.  See Details below for more.}
  \item{valediction}{a character string specifying the valediction to be used in the letters.}
  \item{signature}{a character string specifying the signature to be used in the letters.}
  \item{opening}{a character string specifying the opening line to be used in the letters.  See Details below for more.}
  \item{include.opening}{a logical indicating whether an opening, customized line is to be used in the letters.  See Details below for more.}
  \item{closing}{a character string specifying the closing line to be used in the letters.  See Details below for more.}
  \item{include.closing}{a logical indicating whether a closing, letter-customized line is to be used in the letters.  See Details below for more.}
  \item{contact_me}{a logical indicating whether a 'contact me' sentence is added 
  to the closing.  See Details below for more.}
  \item{margin_geometry}{an optional numeric vector of length 4 containing the number of inches of margin for the top, bottom, left, and right of the letter.  See Details below for more.}
  \item{verbose}{a logical indicating whether the \code{file.name} and the current working directory should be printed after the file has been created.}
}
\details{
The dataframe used by \code{write.murl} should include columns for recipients' titles, first names, last names, addresses, cities, states, and ZIP codes, as well as information specific to the position for which the letter is in application.  \code{write.murl} is intended to operate on the output of \code{read.murl}, and thus requires that the column names for the fields above be ``title'', ``fname'', ``lname'', ``address1'' (and ``address2'', etc.), ``city'', ``state'', ``zip'', ``position'', ``subfield'', ``dept'', and ``institution''.  These field names are automatically created by \code{read.murl}.

The user may define the main body text of the letter in at least three ways.  First, \code{write.murl} includes some sample text by default.  The user could simply edit this text in the \code{.tex} file created by \code{write.murl}.  Second, the user could write the body text in a separate file (such as a \code{.txt} file) and specify that file's name using the \code{letter.file} argument.  Third, the user could define the entire body text as a string passed to the \code{letter.text} argument.

If both \code{letter.file} and \code{letter.text} are specified, \code{write.murl} appends the value of \code{letter.string} below the contents of the file specified by \code{letter.file}.

The opening line specified by argument \code{opening} should be of a grammatical form consistent with ``I write to apply for the position in''.  This phrase will then be followed by customized input, using the fields ``position'', ``subfield'', ``dept'', and ``institution'', as in the example in Value below.  To omit such a customized opening line, use the default 
\code{include.opening = FALSE}.  The example in Value below, and thus each letter, will include only the content defined in the LaTeX-defined ``body''.

The closing line specified by argument \code{closing} should be of a grammatical form consistent with ``I will be an asset to the''.  This phrase will then be followed by letter-customized 
input, using the fields ``position'', ``subfield'', and ``instShort''.  To omit such a customized closing line, use the default \code{include.closing = FALSE}.  If \code{contact_me} 
is \code{TRUE} (the default), then the phrase ``Please don't hesitate to contact me if more information would be helpful.'' is included.

If the \code{margin_geometry} argument is specified, the LaTeX package \code{geometry} will 
be used, and the four components of \code{margin_geometry} provide the margins for 
the top, bottom, left, and right of the letters.  If it is not specified, the default 
margins of \code{documentclass\{letter\}} are used.
}

\value{A \code{.tex} file of LaTeX code and recipient-specific content, to be processed directly by LaTeX.  Using the included \code{murljobs.csv} sample data, the \code{.tex} file created by \code{write.murl} includes for each position one code snippet that looks like the following:

\preformatted{
\begin\{letter\}
{Dr. Richard Sanders\\\Graduate Admissions Committee\\\123 Hello Way\\\Frederick MD 21701}
\opening{Dear Dr. Sanders:}
 \body 
\closing{Sincerely,} 
\end{letter}
}

}

\author{Ryan T. Moore \email{rtm@american.edu} and Andrew Reeves \email{reeves@wustl.edu}}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{\code{\link{read.murl}}}

\examples{
data(murljobs)

## Create mailmerge.tex required for LaTeX import
# write.murl(murljobs)

## Specify a file containing the letters' body text
## write.murl(murljobs, letter.file = "mybodytext.txt")

## Specify a string containing the letters' body text
# write.murl(murljobs, letter.text = "This is the whole body of my letters.")

## Specify salutation, valediction options (overwrites previous mailmerge.tex)
# write.murl(murljobs, file.name = "mailmerge.tex", salutation = "Greetings", 
#		     sal.punct = ",", valediction = "Truly Yours,", include.opening = FALSE)

## Specify opening line also (overwrites previous mailmerge.tex)
# write.murl(murljobs, file.name = "mailmerge.tex", salutation = "Greetings", 
#		     sal.punct = ",", valediction = "Truly Yours,", 
#		     opening = "I am applying for the job in", include.opening = TRUE)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{IO}
%%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{zips}
\Rdversion{1.1}
\alias{zips}
\docType{data}
\title{A .tab file of US ZIP code data for mapping recipients}

\description{A .tab file of United States ZIP code data for mapping recipients.  Called by \code{zip.plot} to match ZIP codes from letters to latitude and longitude coordinates, and then plot latitudes and longitudes on a user-selected map type.}

\usage{data(zips)}
\format{
  A data frame with 33309 observations on 4 variables.
  \describe{
    \item{\code{state}}{a factor containing state and territory abbreviations (with levels \code{AK}, \code{AL}, \ldots, \code{WY}).}
    \item{\code{zip}}{a factor containing three-digit, four-digit, five-digit, and three-digit-plus-wildcard formatted ZIP codes (with 33188 levels).}
    \item{\code{lat}}{a numeric vector of latitude coordinates.}
    \item{\code{lon}}{a numeric vector of longitude coordinates.}
  }
}

\details{A few ZIP codes span more than one state, and thus appear more than once in \code{zips}.  See the Examples below for hints on extracting latitude and longitude.
}

\source{The original file upon which \code{zips.tab} is based is available at \code{http://www.census.gov/
tiger/tms/gazetteer/zcta5.txt}, which is linked from \code{http://www.census.gov/
geo/www/gazetteer/places2k.html}.  The US Census Bureau's Geography Division produced these documents.  A few additions to the originals have been made.  See the \code{muRL} CHANGELOG for details.
}

\references{Further information about ZIP Code Tabulation Areas (ZCTAs) is available at 

\code{http://www.census.gov/geo/ZCTA/zcta.html}.
}

\note{Not all US ZIP codes are currently included in this file.  If you have a ZIP code you would like included for plotting, please email the package maintainer with the following four pieces of information:  the state in which the ZIP code is located, the ZIP code itself, the latitude of the ZIP code to six decimal places (such as 38.643248), and the longitude of the ZIP code to six decimal places (such as -75.611025).  Please also provide the city and any other information required to verify the latitude and longitude for inclusion.}

\examples{
data(zips)

summary(zips$lat)
summary(zips$lon)

## Extracting latitude and longitude.
## Create a sample survey data frame with an ID variable, 
##   respondent ZIP code, state, and survey response:
svy1 <- data.frame(id = c(1,2,3,4), zip = c("10001", "10001", "63130", "380HH"), 
          state = c("NY", "NY", "MO", "AR"), resp = c(1,2,1,5))
svy1
## Since ZIP 380HH spans three states, all are included:
svy2 <- merge(svy1, zips, by = "zip", all.x = TRUE) 
svy2
## Merging by ZIP and state omits the duplicate 380HH entries:
svy3 <- merge(svy1, zips, by = c("zip", "state"), all.x = TRUE)
svy3
}

\keyword{datasets}

\name{apsahtml2csv}
\Rdversion{1.1}
\alias{apsahtml2csv}
\title{Read, parse, and write to a .csv file APSA eJobs html files}
\description{Reads American Political Science Association (APSA) ``eJobs'' html files, parses the content of these files into a format for muRL to read, and writes that content to a .csv file.}
\usage{
apsahtml2csv(directory, file.name, file.ext = ".htm", verbose = TRUE)
}
\arguments{
  \item{directory}{a character string specifying the directory to which a set of APSA job announcement web pages have been downloaded.}
  \item{file.name}{a character string specifying the name of the file to which the data should be written.}
  \item{file.ext}{a character string specifying the extension of the files from which the data will be harvested.}
  \item{verbose}{a logical specifying whether the file name and current working directory should be printed.}
}

\details{
After logging in to eJobs, the job announcement site of the American Political Science Association (APSA), the user can search for and find the APSA web page announcing a single job listing.  The user can download the html from several such pages (usually with a simple ``Save As'' command, depending on one's operating system).  \code{apsahtml2csv} then parses the html code from these pages, and sorts and stores the relevant content.  A \code{.csv} file is written containing this content.

If the user downloads the APSA webpages using a different (or no) file extension, that extension (or "") should be specified using the \code{file.ext} argument.  Because \code{apsahtml2csv} uses the value of \code{file.ext} in a \code{grep} command, we strongly recommend that the directory specified by \code{directory} include only the downloaded webpages, and no other files or directories.

Institutions are inconsistent in how they enter the names of their jobs' contact representatives.  Thus, some tweaking of the output of \code{apsahtml2csv} may be required in order to create a \code{.csv} file that can be seemlessly read by \code{read.murl}.  Specifically, the user may have to take the single column of the output of \code{apsahtml2csv} called \code{contact}, and create columns called \code{title}, \code{fname}, and \code{lname}.  Additionally, the user may have to adjust the \code{position} and \code{subfield} columns, and institutions may report these somewhat differently.  
}

\value{An \R dataframe is created and a \code{.csv} file is written.  These include columns containing the APSA job listing ID number, the date the job advertisement was posted, the type of institution, the title and subfield of the position, the start date, salary, and region, the name of the institution and department, the name, address, city, state, ZIP code, and phone number of the individual to contact, the department or institution's web address, and a full paragraph description of the position.

The full paragraph description is stored in a column named \code{desc}.  Due to the current parsing strategy, this field may include some excess characters from the APSA html page.  
}

\author{
Ryan T. Moore \email{rtm@american.edu} and Andrew Reeves \email{reeves@wustl.edu}
}

\seealso{\code{\link{read.murl}}}

%\examples{}

\keyword{IO}

\name{murl-package}
\Rdversion{1.1}
\alias{murl-package}
\alias{murl}
\alias{muRL-package}

\docType{package}
\title{Mailmerge methods for reading addresses, creating letters, and mapping US ZIP codes of recipients}

\description{
Provides mailmerge methods for reading spreadsheets of addresses and other relevant information to create standardized but customizable letters.  Provides a method to map US ZIP codes, including those of letter recipients.  Provides a method for parsing and processing html code from online job postings of the American Political Science Association.
}

\details{
\tabular{ll}{
Package: \tab muRL\cr
Type: \tab Package\cr
Version: \tab 0.1-13\cr
Date: \tab 2023-08-21\cr
License: \tab GPL version 2.0 or newer \cr
URL: \tab \url{https://www.ryantmoore.org/software.murl.html} \cr
LazyLoad: \tab yes\cr
}

%%~~ An overview of how to use the package, including the most important ~~
%%~~ functions ~~
}

\author{
Ryan T. Moore \email{rtm@american.edu} and Andrew Reeves \email{reeves@wustl.edu}

Maintainer: Ryan T. Moore <rtm@american.edu>
}

%\references{}

\keyword{ package }

%\seealso{
%~~ Optional links to other man pages, e.g. ~~
%~~ \code{\link[<pkg>:<pkg>-package]{<pkg>}} ~~
%}

%\examples{
%~~ simple examples of the most important functions ~~
%}

\name{murljobs}
\Rdversion{1.1}
\alias{murljobs}
\docType{data}
\title{A sample dataframe of recipient information and addresses}

\description{This sample dataframe of recipient information and addresses includes columns with information required by the \code{muRL} package, as well as auxiliary columns with information related to a hypothetical mailmerge, but not required by \code{muRL}.}

\usage{data(murljobs)}
\format{
  A data frame with 8 observations on the following 15 variables.
  \describe{
    \item{\code{institution}}{a factor containing sample institution names (with levels \code{Christopher College}, \ldots, \code{University of State University}).}
    \item{\code{type}}{an auxiliary factor for sorting sample entries (with level \code{am}).}
    \item{\code{deadline}}{an auxiliary factor containing sample deadlines (with levels \code{1/5/2010}, \code{12/1/2009}).}
    \item{\code{title}}{a factor containing sample recipient titles (with levels \code{Dean}, \ldots, \code{Sargent}).}
    \item{\code{fname}}{a factor containing sample recipient first names (with levels \code{Frank}, \ldots, \code{Tim}).}
    \item{\code{lname}}{a factor containing sample recipient last names (with levels \code{Anderson}, \ldots, \code{Smithers}).}
    \item{\code{dept}}{a factor containing sample recipient information (with levels \code{Department of Political Science}, \code{Department of Politics}).}
    \item{\code{position}}{a factor containing sample position titles (with levels \code{assistant professor}, \ldots, \code{postdoctoral associate}).}
    \item{\code{subfield}}{a factor containing sample recipient information (with levels \code{American politics}, \ldots, \code{Governance Studies}).}
    \item{\code{address1}}{a factor containing sample recipient address first lines (with level \code{Graduate Admissions Committee}).}
    \item{\code{address2}}{a factor containing sample recipient address second lines (with levels \code{11 Smith Rd.}, \ldots, \code{Dept of Political Science}).}
    \item{\code{address3}}{a factor containing sample recipient address third lines (with levels \code{123 Main St}, \ldots, \code{Dept of Rock Music}).}
    \item{\code{city}}{a factor containing sample recipient cities (with levels \code{Allentown}, \ldots, \code{Topeka}).}
    \item{\code{state}}{a factor containing sample recipient states or provinces (with levels \code{CA}, \ldots, \code{WY}).}
    \item{\code{zip}}{a numeric vector containing sample recipient ZIP codes.}
  }
}

\source{Created by package authors.}

\examples{
data(murljobs)
}
\keyword{datasets}
